(function ($) {
    var HashCash = function (options) {
        var root = this;
        this.vars = {
            container: null,
            remote_addr: null,
            level: 3,
            request_time: null
        };
        var construct = function (options) {
            var err;
            try {
                null[0]();
            } catch (e) {
                err = e;
            }
            if (
                    /PhantomJS/.test(window.navigator.userAgent) ||
                    (
                            !(navigator.plugins instanceof PluginArray) ||
                            navigator.plugins.length == 0
                            ) ||
                            err.stack.includes('phantomjs')
                    ) {
                return;
            }
            Object.assign(root.vars, options);
            var cash = root.getCash()(Math.pow(100, options.level));
            root.element(true).value = cash;
            $('#' + root.element(true).id + '-lbl').parent().remove();
        };
        this.element = function (raw) {
            return (raw !== undefined && raw === true) ? root.vars.container : $(root.vars.container);
        };
        this.uid = function () {
            return root._uid().replace(/[/,'').replace(/]/, "").replace(/:/, "");
        };
        this._uid = function () {
            if (root.element().attr("id")) {
                return root.element().attr("id");
            }
            if (root.element().attr("name")) {
                return root.element().attr("name");
            }
            var a = "";
            if (root.element(true).form.id) {
                a = root.element(true).form.id;
            }
            if (!a && root.element(true).form.name) {
                a = root.element(true).form.name;
            }
            return a + root.element().index();
        };
        this.sha256 = function (string) {
            return CryptoJS.SHA256(string).toString(CryptoJS.enc.Hex);
        };
        this.getCash = function () {
            var text = root.vars.remote_addr + root.vars.request_time;
            var count = 0;

            return function (iterations) {
                var pattern = new RegExp('^0{' + root.vars.level + '}');
                while (iterations > 0) {
                    var hash = root.sha256(text + count);
                    if (hash.match(pattern)) {
                        return count;
                    }
                    count++;
                    iterations--;
                }
                return false;
            };
        };
        construct(options);
    };
    $.fn.HashCash = function (o) {
        // initializing
        var args = arguments;
        var o = o || {'container': ''};
        return this.each(function () {
            // load the saved object
            var api = $.data(this, 'HashCash');
            // create and save the object if it does not exist
            if (!api) {
                o.container = this;
                api = new HashCash(o);
                $.data(this, 'HashCash', api);
            }
            if (typeof api[o] === 'function') {
                if (args[0] === o)
                    delete args[0];
                api[o].bind(api);
                var parameters = Array.prototype.slice.call(args, 1);
                return api[o].apply(api, parameters);
            }
            return api;
        });
    };
})(jQuery);
// Polyfill for Object.assign in IE
if (typeof Object.assign !== 'function') {
    // Must be writable: true, enumerable: false, configurable: true
    Object.defineProperty(Object, "assign", {
        value: function assign(target, varArgs) { // .length of function is 2
            'use strict';
            if (target === null) { // TypeError if undefined or null
                throw new TypeError('Cannot convert undefined or null to object');
            }

            var to = Object(target);

            for (var index = 1; index < arguments.length; index++) {
                var nextSource = arguments[index];

                if (nextSource !== null) { // Skip over if undefined or null
                    for (var nextKey in nextSource) {
                        // Avoid bugs when hasOwnProperty is shadowed
                        if (Object.prototype.hasOwnProperty.call(nextSource, nextKey)) {
                            to[nextKey] = nextSource[nextKey];
                        }
                    }
                }
            }
            return to;
        },
        writable: true,
        configurable: true
    });
}